import { useWebSocket } from 'ahooks';
import { Button, Col, Row, message } from 'antd';
import Input from 'rc-input';
import { useMemo, useRef, useEffect, useState } from 'react';

enum ReadyState {
  Connecting = 0,
  Open = 1,
  Closing = 2,
  Closed = 3,
}

interface IHistory {
  prompt: string;
  answer: string;
}

const Test = () => {
  const [prompt, setPrompt] = useState<string>('你好');
  const [loading, setLoading] = useState(true);
  const [answer, setAnswer] = useState('');
  const messageHistory = useRef<IHistory[]>([]);
  const { sendMessage } = useWebSocket('wss://glm-api.baibaomen.com/ws', {
    onMessage: (event) => {
      const text = event.data;
      if (text == '{{BBMCPLT}}') {
      } else {
        setAnswer(text);
      }
    },
    onOpen: () => {
      setLoading(false);
      console.log('连接成功！');
    },
    onError: (e) => {
      message.error('连接失败了，请稍后再试！');
    },
  });

  // useEffect(() => {
  //   console.log(readyState);
  //   if (readyState !== ReadyState.Open) {
  //     connect && connect();
  //   }
  //   return () => {
  //     disconnect && disconnect();
  //   };
  // }, []);

  messageHistory.current = useMemo(() => {
    if (messageHistory.current.length > 0)
      messageHistory.current[messageHistory.current.length - 1].answer += answer;
    console.log(messageHistory.current);
    return messageHistory.current;
  }, [answer]);

  function handleSendMessage() {
    sendMessage &&
      sendMessage(
        JSON.stringify({
          prompt: prompt,
          max_length: 2048,
          top_p: 0.7,
          temperature: 0.95,
          history: [messageHistory.current.map((h) => h.prompt)],
          token: 'Uicm6VMjVPdzepbqnwNvpl25xJjRxFekMV8QZdeTLTwacNBl',
        }),
      );
    messageHistory.current.push({ prompt: prompt, answer: '' });
  }

  return (
    <>
      <Input
        placeholder=""
        value={prompt}
        onChange={(e) => {
          setPrompt(e.target.value);
        }}
      />
      <Button onClick={handleSendMessage} loading={loading}>
        发送
      </Button>
      {messageHistory.current.map((item, index) => (
        <Row key={'message-' + index}>
          <Col span={24}>{item.prompt}</Col>
          <Col span={24} dangerouslySetInnerHTML={{ __html: item.answer }}></Col>
        </Row>
      ))}
    </>
  );
};

export default Test;
